
defaults = {
	["criticalThreshold"] = 20,
	["warningThreshold"] = 45,
	["weaponThreshold"] = 40,
	["repairThreshold"] = 1,
	["autoRepair"] = false,
	["autoCharge"] = false,
	["autoRechargeThreshold"] = 10,
	["autoRepairAll"] = false,
	["logRepairs"] = true,
	["isEnabled"] = true,
	["window"] = { ["x"] = 500, ["y"] = 700 },
	["criticalColor"] = { ["r"]=1, ["g"]=0, ["b"]=0, ["a"]=1 },		
	["warningColor"] = { ["r"]=1, ["g"]=1, ["b"]=0, ["a"]=1 },
	["weaponColor" ] = { ["r"]= 0.768627, ["g"]=0, ["b"]=0.882353, ["a"]=1 },
	["BGColor"] = { ["r"]=0, ["g"]=0, ["b"]=0, ["a"]=1 },
	["defaultColor"] = { ["r"]=1, ["g"]=1, ["b"]=1, ["a"]=1 },
}

function catchSlash( option )
	slot = 0
	local options = {}
	local searchResult = { string.match(option,"^(%S*)%s*(.-)$") }
	for i,v in pairs(searchResult) do
		if (v ~= nil and v ~= "") then
			options[i] = string.lower(v)
		end
	end
	if #options == 0 or options[1] == "help" then
			CHAT_SYSTEM:AddMessage(string.format("Usage: /smr [move, charge]"), 1,1,1)
	elseif options[1] == "move" then
		toggleMove()
	elseif options[1] == "charge" and options[2] == nil then
		CHAT_SYSTEM:AddMessage(string.format("Usage: /smr charge [ main, off, backup, backupoff ]"), 1,1,1)
	elseif options[1] == "charge" and (options[2] == "main" or options[2] == "off" or options[2] == "backup" or options[2] == "backupoff") then
		repairCalled = true
		if options[2] == "main" then
			slot = EQUIP_SLOT_MAIN_HAND
			chargeSlot( slot )
		elseif options[2] == "off" then
			slot = EQUIP_SLOT_OFF_HAND
			chargeSlot( slot )
		elseif options[2] == "backup" then
			slot = EQUIP_SLOT_BACKUP_MAIN
			chargeSlot( slot )
		elseif options[2] == "backupoff" then
			slot = EQUIP_SLOT_BACKUP_OFF
			chargeSlot( slot )
		else
			CHAT_SYSTEM:AddMessage(string.format("Usage: /smr charge [ main, off, backup, backupoff ]"), 1,1,1)
		end
	else
		CHAT_SYSTEM:AddMessage(string.format("Usage: /smr [move, charge]"), 1,1,1)
	end
end

function getGemList()
	gemList = {}
	indexes = {}
	--CHAT_SYSTEM:AddMessage(string.format("Total %s %d ", GetBagInfo(BAG_BACKPACK)));
	_,lastBagSlot = GetBagInfo(BAG_BACKPACK) --FindFirstEmptySlotInBag(BAG_BACKPACK)-1
	--CHAT_SYSTEM:AddMessage(string.format("Last Slot %d", lastBagSlot));
	for i=0,lastBagSlot do
		if IsItemSoulGem(SOUL_GEM_TYPE_FILLED, BAG_BACKPACK, i) then
			table.insert(indexes, i)
			if GetSoulGemItemInfo(BAG_BACKPACK, i) == 1 then
				table.insert(gemList, {type = "Petty", index = i, amount = GetSlotStackSize(BAG_BACKPACK, i), tier = GetSoulGemItemInfo(BAG_BACKPACK, i)})
			elseif GetSoulGemItemInfo(BAG_BACKPACK, i) == 2 then
				table.insert(gemList, {type = "Minor", index = i, amount = GetSlotStackSize(BAG_BACKPACK, i), tier = GetSoulGemItemInfo(BAG_BACKPACK, i)})
			elseif GetSoulGemItemInfo(BAG_BACKPACK, i) == 3 then
				table.insert(gemList, {type = "Lesser", index = i, amount = GetSlotStackSize(BAG_BACKPACK, i), tier = GetSoulGemItemInfo(BAG_BACKPACK, i)})
			elseif GetSoulGemItemInfo(BAG_BACKPACK, i) == 4 then
				table.insert(gemList, {type = "Common", index = i, amount = GetSlotStackSize(BAG_BACKPACK, i), tier = GetSoulGemItemInfo(BAG_BACKPACK, i)})
			elseif GetSoulGemItemInfo(BAG_BACKPACK, i) == 5 then
				table.insert(gemList, {type = "Greater", index = i, amount = GetSlotStackSize(BAG_BACKPACK, i), tier = GetSoulGemItemInfo(BAG_BACKPACK, i)})
			elseif GetSoulGemItemInfo(BAG_BACKPACK, i) == 6 then
				table.insert(gemList, {type = "Grand", index = i, amount = GetSlotStackSize(BAG_BACKPACK, i), tier = GetSoulGemItemInfo(BAG_BACKPACK, i)})
			end
		end
	end
	if #gemList > 1 then
		table.sort(gemList, function(a,b) return a.tier < b.tier end)
	end
end

function SMRepairEvent(eventID, bagId, slotId, isNewItem, itemSoundCategory, updateReason)
	if (repairCalled) and (bagId==1) and (removedIndex == slotId) then
		getGemList()
		CHAT_SYSTEM:AddMessage(string.format("bagId: %d, slotId: %d, updateReason: %d", bagId, slotId, updateReason))
		chargeSlot( slot )
	end
end

function chargeSlot( slot )
	local slotName = ""
	removedIndex = nil
	if slot == 4 then
		slotName = "Main Hand"
	elseif slot == 5 then
		slotName = "Off Hand"
	elseif slot == 20 then
		slotName = "Backup Main Hand"
	elseif slot == 21 then
		slotName = "Backup Off Hand"
	end
	getGemList()
	current,max = GetChargeInfoForItem(BAG_WORN, slot)
	gem = gemList[1]
	for i, gemInv in pairs(gemList) do
		CHAT_SYSTEM:AddMessage(string.format("%s at index %d would charge %d and you have %d", gemInv.type, gemInv.index, GetAmountSoulGemWouldChargeItem(BAG_WORN, slot, BAG_BACKPACK, gemInv.index), gemInv.amount))
	end 
	if IsItemChargeable(BAG_WORN, slot) and #gemList >= 1 and (GetAmountSoulGemWouldChargeItem(BAG_WORN, slot, BAG_BACKPACK, gemList[1].index) <= (max-current)) then
			CHAT_SYSTEM:AddMessage(string.format("Charging %s from %d/%d down %d, with %s tier %d", slotName, current,max, max-current, gem.type, gem.tier))
			removedIndex = gem.index
			ChargeItemWithSoulGem(BAG_WORN, slot, BAG_BACKPACK, gem.index)				
		else
			CHAT_SYSTEM:AddMessage(string.format("%s is not chargeable, you have no gems, or item would be overcharged.", slotName))
			repairCalled = false

		end
end

function getWarningColor()
	return sv.warningColor.r, sv.warningColor.g, sv.warningColor.b, sv.warningColor.a
end

function getCriticalColor()
	return sv.criticalColor.r, sv.criticalColor.g, sv.criticalColor.b, sv.criticalColor.a
end

function getWeaponColor()
	return sv.weaponColor.r, sv.weaponColor.g, sv.weaponColor.b, sv.weaponColor.a
end

function getBGColor()
	return sv.BGColor.r, sv.BGColor.g, sv.BGColor.b, sv.BGColor.a
end

function setWarningColor(r,g,b,a)
	sv.warningColor.r = r
	sv.warningColor.g = g
	sv.warningColor.b = b
	sv.warningColor.a = a
	SMRepairUpdate()
end

function setCriticalColor(r,g,b,a)
	sv.criticalColor.r = r
	sv.criticalColor.g = g
	sv.criticalColor.b = b
	sv.criticalColor.a = a
	SMRepairUpdate()
end

function setWeaponColor(r,g,b,a)
	sv.weaponColor.r = r
	sv.weaponColor.g = g
	sv.weaponColor.b = b
	sv.weaponColor.a = a
	SMRepairUpdate()
end

function setBGColor(r,g,b,a)
	sv.BGColor.r = r
	sv.BGColor.g = g
	sv.BGColor.b = b
	sv.BGColor.a = a
	SMRepairUI:SetCenterColor(sv.BGColor.r,sv.BGColor.g,sv.BGColor.b,sv.BGColor.a)
	SMRepairUI:SetEdgeColor(sv.BGColor.r,sv.BGColor.g,sv.BGColor.b,sv.BGColor.a)
	SMRepairUpdate()
end

function setEnabled( val )
	if not val then 
		if not moveMode then SMRepairUI:SetHidden(true) end
		sv.isEnabled = false
	else 
		sv.isEnabled = true
		SMRepairUI:SetHidden(false)
	end
	SMRepairUpdate()
end

function toggleMove()
	if (moveMode) then
		RepairBuffer:Clear()
		moveMode = false
		SMRepairUI:SetHidden(true)
		SMRepairUI:SetMovable(false)
		SMRepairUpdate()	
	else
		SMRepairUI:SetHidden(false)
		RepairBuffer:Clear()
		SMRepairUI:SetMovable(true)
		moveMode = true
		RepairBuffer:SetMaxHistoryLines(12)
		SMRepairUI:SetHeight(264)
		for i=0,11,1 do
			RepairBuffer:AddMessage("---MOVE ME---", 1,1,1,1)
		end
	end
end

function setMenu()
	LAM = LibStub:GetLibrary("LibAddonMenu-1.0")
	local SMRepairSettings = LAM:CreateControlPanel("SMRepairOptions", "SM Repair")
	LAM:AddHeader(SMRepairSettings, "SMRepairVersionHeader", "v1.4.1")
	LAM:AddDescription(SMRepairSettings, "SMRepairInfoText", "Use /smr for slash commands")
	LAM:AddHeader(SMRepairSettings, "SMRepairMainHeader", "Main")
	LAM:AddCheckbox(SMRepairSettings, "SMRepairEnabled", "     Show SM Repair", "Shows/Hides SM Repair", function() return sv.isEnabled end, function(val) setEnabled(val) end )
	LAM:AddColorPicker(SMRepairSettings, "SMRepairBGColor", "     Background Color", "Color of the window background", function() return getBGColor() end, function(r, g, b, a) setBGColor(r, g, b, a) end )
	LAM:AddButton(SMRepairSettings, "SMRepairMoveButton", "Toggle Move Mode", "Click this to force show the window to position it.", toggleMove )
	LAM:AddHeader(SMRepairSettings, "SMRepairAutoHeader", "")
	local autoRepairSubMenu = LAM:AddSubMenu(SMRepairSettings, "SMRepairAutoRepairSub", "Auto Repair Settings", "")
		LAM:AddCheckbox(autoRepairSubMenu, "SMRepairOptionsAuto", "     Auto Repair Equipped", "Auto repair equipped items under set threshold when visiting stores.", function() return sv.autoRepair end, function( val ) sv.autoRepair = val end )
		LAM:AddSlider(autoRepairSubMenu, "SMRepairAutoSlider", "     Auto Repair Threshold", "Under this value, SM Repair will repair all equipped items at stores if Auto Repair is on", 0, 100, 1, function() return sv.repairThreshold end, function( val ) sv.repairThreshold = val end )
		LAM:AddCheckbox(autoRepairSubMenu, "SMRepairOptionsLogAuto", "     Log Repairs to chat", "Sends output to chat for each repaired item.", function() return sv.logRepairs end, function( val ) sv.logRepairs = val end )
	LAM:AddHeader(SMRepairSettings, "SMRepairArmorHeader", "")
	local armorSubMenu = LAM:AddSubMenu(SMRepairSettings, "SMRepairArmorSub", "Armor Settings", "")
			LAM:AddSlider(armorSubMenu, "SMRepairWarningSlider", "     Warning Threshold", "Under this value, SM Repair will populate with warning colored items.", 0, 100, 1, function() return sv.warningThreshold end, function( val ) sv.warningThreshold = val; SMRepairUpdate() end )
			LAM:AddColorPicker(armorSubMenu, "SMRepairWarningColor", "     Warning Color", "Color items under warning threshold will appear.", function() return getWarningColor() end, function(r, g, b, a) setWarningColor(r, g, b, a) end )
			LAM:AddSlider(armorSubMenu, "SMRepairCriticalSlider", "     Critical Threshold", "Under this value, SM Repair will populate with critical colored items.", 0, 100, 1, function() return sv.criticalThreshold end, function( val ) sv.criticalThreshold = val; SMRepairUpdate() end )
			LAM:AddColorPicker(armorSubMenu, "SMRepairCriticalColor", "     Critical Color", "Color items under critical threshold will appear.", function() return getCriticalColor() end, function(r, g, b, a) setCriticalColor(r, g, b, a) end )
	LAM:AddHeader(SMRepairSettings, "SMRepairWeaponHeader", "")
	local chargeSubMenu = LAM:AddSubMenu(SMRepairSettings, "SMRepairChargeSub", "Charge Settings", "")
			LAM:AddSlider(chargeSubMenu, "SMRepairWeaponSlider", "     Visible Threshold", "Under this value, SM Repair will populate with low enchant weapons.", 0, 100, 1, function() return sv.weaponThreshold end, function( val ) sv.weaponThreshold = val; SMRepairUpdate() end )
			LAM:AddColorPicker(chargeSubMenu, "SMRepairWeaponColor", "     Warning Color", "Color items under weapon threshold will appear.", function() return getWeaponColor() end, function(r, g, b, a) setWeaponColor(r, g, b, a) end )
			LAM:AddHeader(chargeSubMenu, "SMRepairComingSoon", "COMING SOON: ")
			LAM:AddCheckbox(chargeSubMenu, "SMRepairOptionsAutoCharge", "     Auto charge weapons", "Automatically charges weapons to near 100% without waste below the Auto Charge Threshold", function() return sv.autoCharge end, function( val ) sv.autoCharge = val end )
			LAM:AddSlider(chargeSubMenu, "SMRepairOptionsAutoChargeThreshold", "     Auto Repair Threshold", "Under this value, SM Repair will repair all equipped items at stores if Auto Repair is on", 0, 100, 1, function() return sv.autoRechargeThreshold end, function( val ) sv.autoRechargeThreshold = val end )

end

function SMRepairInit( eventCode, addOnName )
	SLASH_COMMANDS["/smr"] = catchSlash
	moveMode = false
	--repairCalled = false
	if addOnName ~= "SMRepair" then return end	
	sv = ZO_SavedVars:New("SMRepair", 1, nil, defaults, nil)
	setMenu()
	RepairBuffer:Clear()
	SMRepairUI:SetAnchor(TOPLEFT, SMRepairMain555, TOPLEFT, sv.window.x,sv.window.y)
	SMRepairUI:SetWidth( 200 )
	SMRepairUI:SetHidden(not sv.isEnabled)
	SMRepairUI:SetCenterColor(sv.BGColor.r,sv.BGColor.g,sv.BGColor.b,sv.BGColor.a)
	SMRepairUI:SetEdgeColor(sv.BGColor.r,sv.BGColor.g,sv.BGColor.b,sv.BGColor.a*.08)
	getGemList()
	SMRepairUpdate()
end

function SMRepairUpdate()
	local bool,a,_,b,x,y = SMRepairUI:GetAnchor()
	sv = ZO_SavedVars:New("SMRepair", 1, nil, defaults, nil)
	somethingDamaged = false
	SMRepairUI:SetCenterColor(sv.BGColor.r,sv.BGColor.g,sv.BGColor.b,sv.BGColor.a)
	SMRepairUI:SetEdgeColor(sv.BGColor.r,sv.BGColor.g,sv.BGColor.b,sv.BGColor.a*.08)
	if (not moveMode and sv.isEnabled) then
		SMRepairUI:SetHidden(true)
		sv = ZO_SavedVars:New("SMRepair", 1, nil, defaults, nil)
		equippedCost = 0
		damagedItems = {}
		RepairBuffer:Clear()
		bufferHeight = 0
		maxHistoryLines = 0
		equippedCost = GetItemRepairCost(BAG_WORN,EQUIP_SLOT_CHEST) + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_FEET) + GetItemRepairCost(BAG_WORN, EQUIP_SLOT_HEAD) + GetItemRepairCost(BAG_WORN, EQUIP_SLOT_SHOULDERS) + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HAND) + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_WAIST) + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_LEGS)	+ GetItemRepairCost(BAG_WORN,EQUIP_SLOT_OFF_HAND) + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_BACKUP_OFF)
		
		if ( GetItemCondition(BAG_WORN,EQUIP_SLOT_CHEST) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_CHEST) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Chest              ", slot = EQUIP_SLOT_CHEST, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_CHEST), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_CHEST)})
		end
		if ( GetItemCondition(BAG_WORN,EQUIP_SLOT_HEAD) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_HEAD) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Head               ", slot = EQUIP_SLOT_HEAD, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_HEAD), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HEAD)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_SHOULDERS) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_SHOULDERS) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Shoulders      ", slot = EQUIP_SLOT_SHOULDERS, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_SHOULDERS), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_SHOULDERS)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_HAND) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_HAND) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Hand               ", slot = EQUIP_SLOT_HAND, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_HAND), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HAND)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_WAIST) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_WAIST) ) then
			redrawBuffer() 
			somethingDamaged = true
			table.insert(damagedItems, {name = "Waist              ", slot = EQUIP_SLOT_WAIST, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_WAIST), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_WAIST)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_LEGS) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_LEGS) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Legs                ", slot = EQUIP_SLOT_LEGS, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_LEGS), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_LEGS)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_FEET) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_FEET) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Feet                 ", slot = EQUIP_SLOT_FEET, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_FEET), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_FEET)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_OFF_HAND) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_OFF_HAND) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Off-Hand         ", slot = EQUIP_SLOT_OFF_HAND, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_OFF_HAND), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_OFF_HAND)})
		end
		if ( GetItemCondition(BAG_WORN, EQUIP_SLOT_BACKUP_OFF) <= sv.warningThreshold and DoesItemHaveDurability(BAG_WORN,EQUIP_SLOT_BACKUP_OFF) ) then
			redrawBuffer()
			somethingDamaged = true
			table.insert(damagedItems, {name = "Backup Off     ", slot = EQUIP_SLOT_BACKUP_OFF, condition = GetItemCondition(BAG_WORN,EQUIP_SLOT_BACKUP_OFF), cost=GetItemRepairCost(BAG_WORN,EQUIP_SLOT_BACKUP_OFF)})
		end
		if ( IsItemChargeable(BAG_WORN,EQUIP_SLOT_MAIN_HAND) and getPercentCharged(BAG_WORN, EQUIP_SLOT_MAIN_HAND) <= sv.weaponThreshold ) then
			redrawBuffer()
			table.insert(damagedItems, {name = "Main Hand     ", slot = EQUIP_SLOT_MAIN_HAND, condition = getPercentCharged(BAG_WORN,EQUIP_SLOT_MAIN_HAND), cost=0 })
		end
		if ( IsItemChargeable(BAG_WORN,EQUIP_SLOT_OFF_HAND) and getPercentCharged(BAG_WORN, EQUIP_SLOT_OFF_HAND) <= sv.weaponThreshold ) then
			redrawBuffer()
			table.insert(damagedItems, {name = "Off-Hand         ", slot = EQUIP_SLOT_OFF_HAND, condition = getPercentCharged(BAG_WORN,EQUIP_SLOT_OFF_HAND), cost=0 })
		end
		if ( IsItemChargeable(BAG_WORN,EQUIP_SLOT_BACKUP_MAIN) and getPercentCharged(BAG_WORN, EQUIP_SLOT_BACKUP_MAIN) <= sv.weaponThreshold ) then
			redrawBuffer()
			table.insert(damagedItems, {name = "Backup Main  ", slot = EQUIP_SLOT_BACKUP_MAIN, condition = getPercentCharged(BAG_WORN,EQUIP_SLOT_BACKUP_MAIN), cost=0 })
		end
		if ( IsItemChargeable(BAG_WORN,EQUIP_SLOT_BACKUP_OFF) and getPercentCharged(BAG_WORN, EQUIP_SLOT_BACKUP_OFF) <= sv.weaponThreshold ) then
			redrawBuffer()
			table.insert(damagedItems, {name = "Backup Off     ", slot = EQUIP_SLOT_BACKUP_OFF, condition = getPercentCharged(BAG_WORN,EQUIP_SLOT_BACKUP_OFF), cost=0 })
		end
		table.sort(damagedItems, function(a,b) return a.condition > b.condition end)
		RepairBuffer:SetMaxHistoryLines( maxHistoryLines )
		displayDamaged(damagedItems)
		if somethingDamaged then
			redrawBuffer()			
			RepairBuffer:AddMessage( string.format("Repair All: %dg", equippedCost))
		end
		SMRepairUI:SetHeight( bufferHeight )
	end
end

function redrawBuffer()
	SMRepairUI:SetHidden(false)
	bufferHeight = bufferHeight + 23
	maxHistoryLines  = maxHistoryLines + 1
	RepairBuffer:SetMaxHistoryLines( maxHistoryLines )
	SMRepairUI:SetHeight( bufferHeight )
end

function colorDurability( condition )
	if (condition <= sv.warningThreshold and condition >= sv.criticalThreshold) then
		return sv.warningColor.r, sv.warningColor.g, sv.warningColor.b, sv.warningColor.a
	elseif (condition >= sv.warningThreshold) then
		return sv.defaultColor.r, sv.defaultColor.g, sv.defaultColor.b, sv.defaultColor.a
	else
		return sv.criticalColor.r, sv.criticalColor.g, sv.criticalColor.b, sv.criticalColor.a
	end	
end

function getPercentCharged( bag, slot )
	current,max = GetChargeInfoForItem(bag,slot)
	percent = ((current/max)*100)
	return percent
end

function SMRepairSavePos( self )	
	sv.window.x = self:GetLeft();
	sv.window.y = self:GetTop();	
end

function displayDamaged(damagedItems)
	formatCost = ""
	for _,sorted in ipairs(damagedItems) do
		if (sorted.slot == EQUIP_SLOT_MAIN_HAND) or (sorted.slot == EQUIP_SLOT_BACKUP_MAIN) then
			formatCost = ""
			r,g,b,a = getWeaponColor()
		elseif IsItemChargeable(BAG_WORN,sorted.slot) and ((sorted.slot == EQUIP_SLOT_BACKUP_OFF) or (sorted.slot == EQUIP_SLOT_OFF_HAND)) then
			formatCost = ""
			r,g,b,a = getWeaponColor()
		else
			formatCost = string.format(" - %dg", sorted.cost)
			r,g,b,a = colorDurability( sorted.condition )
		end
		RepairBuffer:AddMessage( string.format("%s: %d%s", sorted.name, sorted.condition, formatCost), r,g,b,a)
	end
end

function logRepairToChat( slot, cost )
	if sv.logRepairs then
		CHAT_SYSTEM:AddMessage(string.format("SM Repair repaired: %s at %dg", slot, cost), 1,1,0)
	end
end

function SMRepairStoreOpen( eventCode, addOnName )
	if sv.autoRepair then
	       totalCost = 0
	       if GetItemCondition(BAG_WORN, EQUIP_SLOT_CHEST) <=sv.repairThreshold then 
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_CHEST)
			logRepairToChat("Chest", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_CHEST))
			RepairItem(BAG_WORN, EQUIP_SLOT_CHEST)
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_HEAD) <= sv.repairThreshold then 
		        totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HEAD)
                        logRepairToChat("Head", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HEAD))
			RepairItem(BAG_WORN, EQUIP_SLOT_HEAD) 
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_SHOULDERS) <= sv.repairThreshold then
                        totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_SHOULDERS)
			logRepairToChat("Shoulders", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_SHOULDERS))
			RepairItem(BAG_WORN, EQUIP_SLOT_SHOULDERS) 
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_HAND) <= sv.repairThreshold then
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HAND)
			logRepairToChat("Hand", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_HAND))
			RepairItem(BAG_WORN, EQUIP_SLOT_HAND)
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_WAIST) <= sv.repairThreshold then
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_WAIST)
			logRepairToChat("Waist", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_WAIST))
			RepairItem(BAG_WORN, EQUIP_SLOT_WAIST)
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_LEGS) <= sv.repairThreshold then
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_LEGS)
			logRepairToChat("Legs", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_LEGS))
			RepairItem(BAG_WORN, EQUIP_SLOT_LEGS)
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_FEET) <= sv.repairThreshold then
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_FEET)
			logRepairToChat("Feet", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_FEET))
			RepairItem(BAG_WORN, EQUIP_SLOT_FEET)
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_OFF_HAND) <= sv.repairThreshold then
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_OFF_HAND)
			logRepairToChat("Off-Hand", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_OFF_HAND))
			RepairItem(BAG_WORN, EQUIP_SLOT_OFF_HAND)
		end
		if GetItemCondition(BAG_WORN, EQUIP_SLOT_BACKUP_OFF) <= sv.repairThreshold then
			totalCost = totalCost + GetItemRepairCost(BAG_WORN,EQUIP_SLOT_BACKUP_OFF)
			logRepairToChat("Backup Off-Hand", GetItemRepairCost(BAG_WORN,EQUIP_SLOT_BACKUP_OFF))
			RepairItem(BAG_WORN, EQUIP_SLOT_BACKUP_OFF)
		end
		if sv.logRepairs then
		   CHAT_SYSTEM:AddMessage(string.format("SM Repair Total repaired: %dg", totalCost), 1,1,0)
		end
	end
end

EVENT_MANAGER:RegisterForEvent( "SMRepair", EVENT_ADD_ON_LOADED, SMRepairInit )
EVENT_MANAGER:RegisterForEvent( "SMRepair", EVENT_OPEN_STORE, SMRepairStoreOpen)
EVENT_MANAGER:RegisterForEvent( "SMRepair", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, SMRepairEvent)